package com.winhc.kafka.consumer;

import com.winhc.common.enums.CompanyEnum;
import com.winhc.config.ConfigConstant;
import com.winhc.kafka.KafkaProduce;
import com.winhc.service.RelationService;
import com.winhc.utils.CompanyUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.listener.ConsumerAwareListenerErrorHandler;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;

/**
 * @author π
 * @Description:人员合并
 * @date 2021/5/17 16:12
 */
@Slf4j
//@Service
@AllArgsConstructor
@Deprecated
public class KafkaConsumerPersonMergeV2 {

    private final Map<String, RelationService> map;
    @Autowired
    KafkaProduce kafkaProduce;
    @Autowired
    ConfigConstant configConstant;

    @KafkaListener(id = "${spring.kafka.topic_person_merge_v2}"
            , topics = "${spring.kafka.topic_person_merge_v2}"
            , groupId = "${spring.kafka.consumer.group-id}", containerFactory = "containerFactory", errorHandler = "KafkaConsumerPersonMergeV2")
    public void consumerCompanyNode(List<ConsumerRecord<?, ?>> records) {
        List<Map<String, Object>> listMap = CompanyUtils.map(records);
        this.map.get(CompanyEnum.TopicType.PERSON_MERGE_V2.VALUE).save(CompanyUtils.filterList(listMap, CompanyEnum.TopicType.PERSON_MERGE_V2.CODE));
    }

    /**
     * 因为手动确认消费，若消费失败，记录重刷
     */
    @Bean("KafkaConsumerPersonMergeV2")
    public ConsumerAwareListenerErrorHandler dealError() {
        return (message, e, consumer) -> {
            List<String> list = CompanyUtils.toMessage((List<ConsumerRecord>) message.getPayload());
            for (String msg : list) {
                kafkaProduce.produce(configConstant.topic_case, msg);
            }
            log.error("KafkaConsumerCaseMerge error: {}", e.toString());
            return null;
        };
    }
}
